`
java-mans
  • 浏览: 11391896 次
文章分类
社区版块
存档分类
最新评论

hdu 1072 Nightmare BFS

 
阅读更多

Nightmare

Time Limit: 2000/1000 MS (Java/Others)Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 3828Accepted Submission(s): 1907


Problem Description
Ignatius had a nightmare last night. He found himself in a labyrinth with a time bomb on him. The labyrinth has an exit, Ignatius should get out of the labyrinth before the bomb explodes. The initial exploding time of the bomb is set to 6 minutes. To prevent the bomb from exploding by shake, Ignatius had to move slowly, that is to move from one area to the nearest area(that is, if Ignatius stands on (x,y) now, he could only on (x+1,y), (x-1,y), (x,y+1), or (x,y-1) in the next minute) takes him 1 minute. Some area in the labyrinth contains a Bomb-Reset-Equipment. They could reset the exploding time to 6 minutes.

Given the layout of the labyrinth and Ignatius' start position, please tell Ignatius whether he could get out of the labyrinth, if he could, output the minimum time that he has to use to find the exit of the labyrinth, else output -1.

Here are some rules:
1. We can assume the labyrinth is a 2 array.
2. Each minute, Ignatius could only get to one of the nearest area, and he should not walk out of the border, of course he could not walk on a wall, too.
3. If Ignatius get to the exit when the exploding time turns to 0, he can't get out of the labyrinth.
4. If Ignatius get to the area which contains Bomb-Rest-Equipment when the exploding time turns to 0, he can't use the equipment to reset the bomb.
5. A Bomb-Reset-Equipment can be used as many times as you wish, if it is needed, Ignatius can get to any areas in the labyrinth as many times as you wish.
6. The time to reset the exploding time can be ignore, in other words, if Ignatius get to an area which contain Bomb-Rest-Equipment, and the exploding time is larger than 0, the exploding time would be reset to 6.

Input
The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.
Each test case starts with two integers N and M(1<=N,Mm=8) which indicate the size of the labyrinth. Then N lines follow, each line contains M integers. The array indicates the layout of the labyrinth.
There are five integers which indicate the different type of area in the labyrinth:
0: The area is a wall, Ignatius should not walk on it.
1: The area contains nothing, Ignatius can walk on it.
2: Ignatius' start position, Ignatius starts his escape from this position.
3: The exit of the labyrinth, Ignatius' target position.
4: The area contains a Bomb-Reset-Equipment, Ignatius can delay the exploding time by walking to these areas.

Output
For each test case, if Ignatius can get out of the labyrinth, you should output the minimum time he needs, else you should just output -1.
题意在在时t=6内跑出迷宫 1是能走的路 0是墙 2是起点 3是终点 4可以使之前的时间不算 只要能从新在时间t内从当前位置跑出即可
当t=6的时候跑出不算 且当t=6的时候跑到4 也 不算 时间不能重置

Sample Input
33 32 1 11 1 01 1 34 82 1 1 0 1 1 1 01 0 4 1 1 0 4 11 0 0 0 0 0 0 11 1 1 4 1 1 1 35 81 2 1 1 1 1 1 4 1 0 0 0 1 0 0 1 1 4 1 0 1 1 0 1 1 0 0 0 0 3 0 1 1 1 4 1 1 1 1 1

Sample Output
4-113

Author
Ignatius.L
#include<stdio.h>
#include<string.h>
struct haha
{
int x;
int y;
int ti;//剩余时间
int step;
}b[105000];
int a[15][15],s_x,s_y,e_x,e_y;
int c[4][2]={-1,0,1,0,0,-1,0,1};
int head,tail;
int bfs()
{
int i,x1,y1;
while(head<tail)
{
++head;
if(b[head].ti>1)
{
for(i=0;i<4;i++)
{
x1=b[head].x+c[i][0];
y1=b[head].y+c[i][1];
if(a[x1][y1]!=0)
{
b[++tail].step=b[head].step+1;
b[tail].x=x1;
b[tail].y=y1;
b[tail].ti=b[head].ti-1;
if(a[x1][y1]==4)
{
b[tail].ti=6;a[x1][y1]=0;
}
}
}
}
if(b[head].x==e_x&&b[head].y==e_y) return b[head].step;
}
return -1;
}
int main()
{
int t,i,j,hang,lie;
scanf("%d",&t);
while(t--)
{

scanf("%d %d",&hang,&lie);
memset(a,0,sizeof(a));
for(i=1;i<=hang;i++)
for(j=1;j<=lie;j++)
{
scanf("%d",&a[i][j]);
if(a[i][j]==2) {s_x=i;s_y=j;}
if(a[i][j]==3) {e_x=i;e_y=j;}
}
head=0;tail=1;b[1].x=s_x;b[1].y=s_y;b[1].ti=6;b[1].step=0;
printf("%d\n",bfs());
}
return 0;
}
虽然AC了 但是还是有点不明白 为什么走到4 只能走一次啊???
网上大多是这样含糊的描述了一下: 这题重要的走过的点可以走第二次,但是我们会发现当走过4时我们可以标记为0,因为回走是没必要
无论你怎么走 如果重复经过同一个重置时间的点那么必然得不到最短时间 所以将其标记

下面是对应的 优先队列方案 为网上复制
#include<iostream>
using namespace std;
#include<queue>
struct node
{
int x,y,time,step;
};
int map[20][20];
int n,m,sx,sy,dx,dy;
queue<node> que;
node now,next;
int dir[4][2]={-1,0,1,0,0,-1,0,1};
int BFS()
{
now.x=sx;
now.y=sy;
now.time=6;
now.step=0;
while(!que.empty()) que.pop();
que.push(now);
while(!que.empty())
{
now=que.front();
que.pop();
if(now.x==dx&&now.y==dy&&now.time>0) return now.step;
for(int i=0;i<4;i++)
{
next.x=now.x+dir[i][0];
next.y=now.y+dir[i][1];
next.time=now.time-1;
next.step=now.step+1;
if(next.x>=0&&next.y>=0&&next.x<n&&next.y<m&&map[next.x][next.y]!=0&&next.time>0)
{
if(map[next.x][next.y]==4)
{
next.time=6;
map[next.x][next.y]=0;
}
que.push(next);
}
}
}
return -1;
}
int main()
{
int T,i,j;
scanf("%d",&T);
while(T--)
{
scanf("%d%d",&n,&m);
for(i=0;i<n;i++)
for(j=0;j<m;j++)
{
scanf("%d",&map[i][j]);
if(map[i][j]==2) {sx=i;sy=j;}
else if(map[i][j]==3) {dx=i;dy=j;}
}
printf("%d\n",BFS());
}
}

分享到:
评论

相关推荐

Global site tag (gtag.js) - Google Analytics